module ComposableFixtures
  class ComposableFixtureSetDefinition
    include Enumerable
    
    attr_reader :set_names
    
    def initialize(composition_name, set_names)
      @name, @set_names = composition_name, set_names
    end

    def each(&block)
      @set_names.each(&block)
    end
    
    
    def as_filename_to_yaml
      set_names = @set_names.dup
      set_name  = set_names.pop
      set_def   = FixtureSetRepository.instance.fetch(set_name)
      composer  = FixtureComposer.new(set_def.set_names)
      
      set_names.reduce(composer) do |acc_composer, set_name|
        set_def = FixtureSetRepository.instance.fetch(set_name)        
        composer.concat!(
          FixtureComposer.new(set_def.set_names).as_filename_to_yaml
        )
      end.as_filename_to_yaml
    end
  end
end
