module ComposableFixtures
  class FixtureComposer
    def initialize(fixture_names)
      @fixture_names = fixture_names
      @filename_to_concatd_fixtures = {}
    end

    def as_filename_to_yaml
      @fixture_names.each do |fixture_name|
        set_def = FixtureSetRepository.instance.fetch(fixture_name)
        set_def.each do |fixture_set_path|
          Dir.foreach(fixture_set_path) do |filename|
            next if filename =~ /^\./
            extract_fixture_from(fixture_set_path, filename)
          end
        end
      end
      @filename_to_concatd_fixtures
    end

    def extract_fixture_from(fixture_set_path, filename)
      File.open(File.join(fixture_set_path, filename), "r") do |f|
        contents = f.readlines
        
        if @filename_to_concatd_fixtures.has_key?(filename)
          # Remove "---" at top of YAML
          contents.shift
        else
          # We haven't loaded any of this file yet so initialize it with a string
          @filename_to_concatd_fixtures[filename] = ""
        end
        
        @filename_to_concatd_fixtures[filename] += contents.join("\n")
      end
    end
  end
end

