require 'singleton'

module ComposableFixtures
  class FixtureSetRepository
    include Singleton
    include Enumerable

    def register(name, set_definition)
      repository[name] = set_definition
    end

    def fetch(name)
      repository.fetch(name)
    end

    def each(&block)
      repository.values.each(&block)
    end
    
    private
    
    def repository
      @repository ||= {}
    end
  end  
end
